-- ================================================================== --
-- SISTEMA         : PEDIDO                                           --
-- DATA DA CRIAO : INCIO - 12/08/2002                              --
-- CRIAO         : Andr Rodrigo                                    --
-- OBJETIVO        : Gera comisso do vendedor por item do pedido     --
-- ================================================================== --
CREATE OR REPLACE PROCEDURE GRAVA_VENDITEMPED(
   P_CDFILIAL      IN ITEMPEDIDO.CDFILIAL%TYPE,
   P_NRPEDIDO      IN ITEMPEDIDO.NRPEDIDO%TYPE,
   P_CDVENDEDOR    IN VENDITEMPED.CDVENDEDOR%TYPE,
   P_VRPECOMITPED  IN VENDITEMPED.VRPECOMITPED%TYPE,
   P_CDOPERADOR    IN OPERADOR.CDOPERADOR%TYPE  DEFAULT NULL,
   P_NRITEMALTER   IN ITEMPEDIDO.NRITEMPED%TYPE DEFAULT NULL
) IS

   V_CTPEVEND   NUMBER;
   V_VRCOMISANT NUMBER;
BEGIN
   FOR C_ITEM IN
      (SELECT NRITEMPED, IDSITITEMPED
       FROM ITEMPEDIDO
       WHERE
         (CDFILIAL = P_CDFILIAL) AND
         (NRPEDIDO = P_NRPEDIDO)) LOOP

      IF(C_ITEM.IDSITITEMPED = '1')OR(C_ITEM.IDSITITEMPED = '2')OR(C_ITEM.IDSITITEMPED = '3')THEN
         SELECT COUNT(*) INTO V_CTPEVEND
         FROM VENDITEMPED
         WHERE
           (CDFILIAL   = P_CDFILIAL) AND
           (NRPEDIDO   = P_NRPEDIDO) AND
           (NRITEMPED  = C_ITEM.NRITEMPED) AND
           (CDVENDEDOR = P_CDVENDEDOR);

         IF V_CTPEVEND = 0 THEN
            INSERT INTO VENDITEMPED
              (CDFILIAL, NRPEDIDO, NRITEMPED,
               CDVENDEDOR, VRPECOMITPED)
            VALUES
              (P_CDFILIAL, P_NRPEDIDO, C_ITEM.NRITEMPED,
               P_CDVENDEDOR, P_VRPECOMITPED);

            IF (P_NRITEMALTER IS NULL) OR (P_NRITEMALTER <> C_ITEM.NRITEMPED) THEN
               INSERT INTO HISITEMPED
                   (CDFILIAL, IDSITATUHIST, NRITEMPED, IDSITANTHIST, IDALTHISTITE,
                    DTHRHIST, NRPEDIDO, CDOPEMANHIST,CDVENDORIG, VRCOMISSORIG,CDVENDATUAL,VRCOMISATUAL)
               VALUES
                   (P_CDFILIAL, C_ITEM.IDSITITEMPED, C_ITEM.NRITEMPED, C_ITEM.IDSITITEMPED, '3',
                    SYSDATE, P_NRPEDIDO, P_CDOPERADOR, NULL, NULL, P_CDVENDEDOR, P_VRPECOMITPED);
            END IF;
         ELSE
            SELECT VRPECOMITPED INTO V_VRCOMISANT
            FROM VENDITEMPED
            WHERE
               (CDFILIAL   = P_CDFILIAL) AND
               (NRPEDIDO   = P_NRPEDIDO) AND
               (NRITEMPED  = C_ITEM.NRITEMPED) AND
               (CDVENDEDOR = P_CDVENDEDOR);

            UPDATE VENDITEMPED
            SET VRPECOMITPED = P_VRPECOMITPED
            WHERE
               (CDFILIAL   = P_CDFILIAL) AND
               (NRPEDIDO   = P_NRPEDIDO) AND
               (NRITEMPED  = C_ITEM.NRITEMPED) AND
               (CDVENDEDOR = P_CDVENDEDOR);

            IF (P_NRITEMALTER IS NULL) OR (P_NRITEMALTER <> C_ITEM.NRITEMPED) THEN
               INSERT INTO HISITEMPED
                   (CDFILIAL, IDSITATUHIST, NRITEMPED, IDSITANTHIST, IDALTHISTITE,
                    DTHRHIST, NRPEDIDO, CDOPEMANHIST,CDVENDORIG, VRCOMISSORIG,CDVENDATUAL,VRCOMISATUAL)
               VALUES
                   (P_CDFILIAL, C_ITEM.IDSITITEMPED, C_ITEM.NRITEMPED, C_ITEM.IDSITITEMPED, '3',
                    SYSDATE, P_NRPEDIDO, P_CDOPERADOR, P_CDVENDEDOR, V_VRCOMISANT, P_CDVENDEDOR, P_VRPECOMITPED);
            END IF;
         END IF;
      END IF;
   END LOOP;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_VENDITEMPED','4.05.125'); END;
/

